Redmine - Patch #20369

Use String#casecmp for case insensitive comparison
2015-07-19 06:41 - Go MAEDA

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Code cleanup/refactoring Estimated time: 0.00 hour
Target version: 3.2.0

Description

String#casecmp is faster than String#downcase. We can save some CPU cycles by replacing String#downcase with
String#casecmp.

The following is a script to benchmark.
#!/usr/bin/env ruby

def measure (p)

tl = Time.now
1000000.times {p.call}
t2 = Time.now
t2 - tl
end
strl = (1..100).map {('A'..'z'"').to_a.sample}.join
str2 = strl.downcase
puts "String#casecmp : #{measure (->{ strl.casecmp(str2) == 0})} sec"
puts "String#downcase : #{measure (->{ strl.downcase == str2 })} sec"

Here is a result. casecmp is remarkably faster than downcase.

laphroaig:patches maeda$ ruby casecmp-vs-downcase.rb

String#casecmp : 0.358929 sec

String#downcase : 0.557218 sec

Related issues:

Related to Redmine - Defect #20278: Wrong syntax for resizing inline images w... Closed
Related to Redmine - Defect #27780: Case-insensitive matching fails for Unico... Closed

Associated revisions

Revision 14484 - 2015-08-12 14:54 - Toshi MARUYAMA

use String#casecmp for case insensitive comparison (#20369)

Contributed by Go MAEDA.

Revision 14498 - 2015-08-15 08:44 - Jean-Philippe Lang
#downcase no longer needed after r14484 (#20369).

Revision 14502 - 2015-08-15 09:07 - Jean-Philippe Lang
#downcase no longer needed after r14484 (#20369).

Revision 14676 - 2015-10-15 20:31 - Jean-Philippe Lang
Fixed unsafe call to #casecmp (#20369, #21000).

History

#1 - 2015-07-19 06:45 - Toshi MARUYAMA

- Target version set to 3.2.0
#2 - 2015-07-19 09:45 - Go MAEDA

- Related to Defect #20278: Wrong syntax for resizing inline images will throw a 500 error added

#3 - 2015-08-12 15:39 - Toshi MARUYAMA

- Status changed from New to Closed

Committed in trunk r14484, thanks.

#4 - 2017-12-12 04:07 - Go MAEDA

- Related to Defect #27780: Case-insensitive matching fails for Unicode filenames when referring to attachments in text formatting added

Files

replace-downcase-with-casecmp.diff 4.57 KB 2015-07-19 Go MAEDA
